package jp.ogakisoft.quiz.client;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

public abstract class AbstractPanel implements IPanel {

	public void clear() {
		RootPanel.get("centerTitle").clear();
		RootPanel.get("bottomTitle").clear();
		RootPanel.get("buttonTitle").clear();
		RootPanel.get("topContainer").clear();
		RootPanel.get("centerContainer").clear();
		RootPanel.get("bottomContainer").clear();
		RootPanel.get("buttonContainer").clear();
	}

	public void show(QuizServiceAsync service) {
	}

	public abstract class Callback implements AsyncCallback<Object> {
		public void onFailure(Throwable caught) {
			final DialogBox dialogBox = new DialogBox();
			HTML serverResponseLabel = new HTML();
			Button closeButton = new Button(constant.CLOSE());
			closeButton.getElement().setId("closeButton");
			VerticalPanel dialogVPanel = new VerticalPanel();
			dialogVPanel.addStyleName("dialogVPanel");
			dialogVPanel.add(serverResponseLabel);
			dialogVPanel.setHorizontalAlignment(VerticalPanel.ALIGN_RIGHT);
			dialogVPanel.add(closeButton);
			dialogBox.setAnimationEnabled(true);
			dialogBox.setWidget(dialogVPanel);
			dialogBox.setText(constant.FAILURE());
			dialogBox.center();
			serverResponseLabel.setText("");
			serverResponseLabel.addStyleName("error");
			serverResponseLabel.setHTML(constant.ERR_MSG1());
			closeButton.setFocus(true);
			closeButton.addClickHandler(new ClickHandler() {
				public void onClick(ClickEvent event) {
					dialogBox.hide();
				}
			});
		}
		public void onSuccess(Object result) {}
	}

}
