package jp.ogakisoft.quiz.client;

import java.util.List;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RadioButton;
import com.google.gwt.user.client.ui.RootPanel;

public class StartPanel extends AbstractPanel {
	private RadioButton radio[];
	private Button nextButton = null;

	public void show(final QuizServiceAsync service) {
		clear();
		service.quizAllTitles(new AbstractPanel.Callback() {
			@Override
			public void onSuccess(Object obj) {
				List<String> list = (List<String>) obj;
				if (list.size() == 0){
					RootPanel.get("centerContainer").add(new HTML(constant.NOTHING()+"</br>"));
					return;
					//service.load(null);
				}
				radio = new RadioButton[list.size()];
				for (int ix = 0; ix < list.size(); ix++) {
					String[] fields = list.get(ix).split(";");
					radio[ix] = new RadioButton("group");
					radio[ix].setText("" + (ix + 1) + ":" + fields[1]);
					radio[ix].setName(fields[0]);
					RootPanel.get("centerContainer").add(radio[ix]);
					RootPanel.get("centerContainer").add(new HTML("</br>"));
				}
				if (radio.length == 1) {
					radio[0].setValue(true);
				}
				if (radio.length > 0) {
					nextButton = new Button(constant.NEXT());
					nextButton.addClickHandler(new ClickHandler() {
						public void onClick(ClickEvent event) {
							String id = "";
							for (int ix = 0; ix < radio.length; ix++) {
								if (radio[ix].getValue()) {
									id = radio[ix].getName();
									break;
								}
							}
							if (id != "")
								new QuizPanel(id).show(service);
						}
					});
					RootPanel.get("buttonContainer").add(nextButton);
				}
				Label label = new Label(constant.SELECT_TITLE());
				RootPanel.get("topContainer").add(label);
			}
		});
	}
}